from PyQt5.QtWidgets import QMainWindow, QApplication, QPushButton, QTextEdit
from PyQt5 import uic, QtCore, QtGui, QtWidgets
from PyQt5.QtCore import QDateTime,Qt
from pyqtgraph import PlotWidget
import sys


class UI(QMainWindow):
    def __init__(self):
        super(UI, self).__init__()
        uic.loadUi("mainwindow.ui", self)

#Plotting datas into Graph
        self.desymskPlot(1,[100,160,212,355,362,420,505,521,622,650], [21,32,34,32,33,31,29,32,35,45])
        self.desymskPlot(2,[100,160,222,345,352,410,505,511,622,640], [21,32,34,32,33,31,29,32,35,45])

#Timer for date&time at bottom right corner
        self.timer = QtCore.QTimer(self)
        self.timer.setInterval(1000)
        self.timer.timeout.connect(self.displayTime)
        self.timer.start()

#Validate Temp LineEdit Fields to be integers
        self.mainTempFreq.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$'))) #0-255
        self.mainTempRF.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$')))    #0-255
        self.mainTempRH.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^[1-9][0-9]?$|^100$'))) #1-100

#Signals for Temp Buttons
        self.pBTempSweep_ok.clicked.connect(lambda: self.pB_okTempbtnFunc(1))
        self.pBFreqSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBRFSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBRHSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBbackTomain.clicked.connect(lambda: self.mainStack.setCurrentIndex(0))
        #self.pBabout.clicked.connect(lambda: self.mainStack.setCurrentIndex(2))
        #self.pBbackAbtToMain.clicked.connect(lambda: self.mainStack.setCurrentIndex(0))

# Validate Freq LineEdit Fields to be integers
        self.mainFreqTemp.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$')))  # 0-255
        self.mainFreqRF.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$')))  # 0-255
        self.mainFreqRH.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^[1-9][0-9]?$|^100$')))  # 1-100

# Signals for Freq Buttons
        self.pBFreqSweep_ok.clicked.connect(lambda: self.pB_okFreqbtnFunc(1))
        self.pBTempSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBRFSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBRHSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBbackTomain.clicked.connect(lambda: self.mainStack.setCurrentIndex(0))
        #self.pBabout.clicked.connect(lambda: self.mainStack.setCurrentIndex(2))
        #self.pBbackAbtToMain.clicked.connect(lambda: self.mainStack.setCurrentIndex(0))

# Validate RF LineEdit Fields to be integers
        self.mainRFTemp.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$')))  # 0-255
        self.mainRFFreq.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$')))  # 0-255
        self.mainRFRH.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^[1-9][0-9]?$|^100$')))  # 1-100

# Signals for RF Buttons
        self.pBRFSweep_ok.clicked.connect(lambda: self.pB_okRFbtnFunc(1))
        self.pBTempSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBFreqSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBRHSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBbackTomain.clicked.connect(lambda: self.mainStack.setCurrentIndex(0))
        # self.pBabout.clicked.connect(lambda: self.mainStack.setCurrentIndex(2))
        #self.pBbackAbtToMain.clicked.connect(lambda: self.mainStack.setCurrentIndex(0))

# Validate RH LineEdit Fields to be integers
        self.mainRHTemp.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$')))  # 0-255
        self.mainRHFreq.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])$')))  # 0-255
        self.mainRHRF.setValidator(QtGui.QRegExpValidator(QtCore.QRegExp('^[1-9][0-9]?$|^100$')))  # 1-100

# Signals for RH Buttons
        self.pBRHSweep_ok.clicked.connect(lambda: self.pB_okRHbtnFunc(1))
        self.pBTempSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBFreqSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBRHSweep_ok.clicked.connect(lambda: self.mainStack.setCurrentIndex(1))
        self.pBbackTomain.clicked.connect(lambda: self.mainStack.setCurrentIndex(0))
        # self.pBabout.clicked.connect(lambda: self.mainStack.setCurrentIndex(2))
        #self.pBbackAbtToMain.clicked.connect(lambda: self.mainStack.setCurrentIndex(0))

#Signals to change between the pages
        self.rB_TempSweep.clicked.connect(lambda: self.rB_btnFunc(0))
        self.rB_FreqSweep.clicked.connect(lambda: self.rB_btnFunc(1))
        self.rB_RFpowSweep.clicked.connect(lambda: self.rB_btnFunc(2))
        self.rB_RhSweep.clicked.connect(lambda: self.rB_btnFunc(3))

        self.show()

    def rB_btnFunc(self,a):
        self.mainSelStack.setCurrentIndex(a)
        self.graphSelStack.setCurrentIndex(a)

#Form Validator for temp
    def pB_okTempbtnFunc(self, a):

        if self.mainTempFreq.text() != "" and self.mainTempRF.text() != "" and self.mainTempRH.text() != "" and self.mainTempStr.currentText() != "" and self.mainTempStp.currentText() != "" and self.mainTempStep.currentText() != "":
            self.mainStack.setCurrentIndex(a)
            self.graphTempFreq.setText(self.mainTempFreq.text())
            self.graphTempRF.setText(self.mainTempRF.text())
            self.graphTempRH.setText(self.mainTempRH.text())
            self.graphTempStr.setText(self.mainTempStr.currentText())
            self.graphTempStp.setText(self.mainTempStp.currentText())
            self.graphTempStep.setText(self.mainTempStep.currentText())
            self.lberrorMsg.setText("")
        else:
            self.lberrorMsg.setText("please fill in all required fields")
            print ("running")

# Form Validator for Freq
    def pB_okFreqbtnFunc(self, a):

        if self.mainFreqTemp.text() != "" and self.mainFreqRF.text() != "" and self.mainFreqRH.text() != "" and self.mainFreqStr.currentText() != "" and self.mainFreqStp.currentText() != "" and self.mainFreqStep.currentText() != "":
            self.mainStack.setCurrentIndex(a)
            self.graphFreqTemp.setText(self.mainFreqTemp.text())
            self.graphFreqRF.setText(self.mainFreqRF.text())
            self.graphFreqRH.setText(self.mainFreqRH.text())
            self.graphFreqStr.setText(self.mainFreqStr.currentText())
            self.graphFreqStp.setText(self.mainFreqStp.currentText())
            self.graphFreqStep.setText(self.mainFreqStep.currentText())
            self.lberrorMsg.setText("")
        else:
            self.lberrorMsg.setText("please fill in all required fields")
            print("running")

# Form Validator for RF
    def pB_okRFbtnFunc(self, a):

        if self.mainRFTemp.text() != "" and self.mainRFFreq.text() != "" and self.mainRFRH.text() != "" and self.mainRFStr.currentText() != "" and self.mainRFStp.currentText() != "" and self.mainRFStep.currentText() != "":
            self.mainStack.setCurrentIndex(a)
            self.graphRFTemp.setText(self.mainRFTemp.text())
            self.graphRFFreq.setText(self.mainRFFreq.text())
            self.graphRFRH.setText(self.mainRFRH.text())
            self.graphRFStr.setText(self.mainRFStr.currentText())
            self.graphRFStp.setText(self.mainRFStp.currentText())
            self.graphRFStep.setText(self.mainRFStep.currentText())
            self.lberrorMsg.setText("")
        else:
            self.lberrorMsg.setText("please fill in all required fields")
            print("running")

# Form Validator for RH
    def pB_okRHbtnFunc(self, a):

        if self.mainRHTemp.text() != "" and self.mainRHFreq.text() != "" and self.mainRHRF.text() != "" and self.mainRHStr.currentText() != "" and self.mainRHStp.currentText() != "" and self.mainRHStep.currentText() != "":
            self.mainStack.setCurrentIndex(a)
            self.graphRHTemp.setText(self.mainRHTemp.text())
            self.graphRHFreq.setText(self.mainRHFreq.text())
            self.graphRHRF.setText(self.mainRHRF.text())
            self.graphRHStr.setText(self.mainRHStr.currentText())
            self.graphRHStp.setText(self.mainRHStp.currentText())
            self.graphRHStep.setText(self.mainRHStep.currentText())
            self.lberrorMsg.setText("")
        else:
            self.lberrorMsg.setText("please fill in all required fields")
            print("running")

#Time
    def displayTime(self):
        self.lbdateTime.setText(QtCore.QDateTime.currentDateTime().toString(Qt.DefaultLocaleLongDate))

#Graph
    def desymskPlot(self, a, x, y):
        styles = {"color": "#000", "font-size": "13px"}

    #Top Graph
        if a == 1:
            self.graphWidget.setBackground('w')
            self.graphWidget.setLabel("left", "delta phi [ΔΦ]", **styles)
            self.graphWidget.setLabel("bottom", "T [°C]", **styles)
            self.graphWidget.showGrid(x=True, y=True) #GRID OPTION
            self.graphWidget.plot(x, y)

            #self.graphWidget.addLegend()

            #self.graphWidget.setXRange(0, 0, padding=0) #TODO - change with respect to req
            #self.graphWidget.setYRange(0, 0, padding=0)

    #Bottom Graph
        elif a==2:
            self.graphWidget_2.setBackground('w')
            self.graphWidget_2.setLabel("left", "loss [dB]", **styles)
            self.graphWidget_2.setLabel("bottom", "T [°C]", **styles)
            self.graphWidget_2.showGrid(x=True, y=True) #GRID OPTION
            self.graphWidget_2.plot(x, y)


app = QApplication(sys.argv)
window = UI()
app.exec_()
